//       _________ __                 __
//      /   _____//  |_____________ _/  |______     ____  __ __  ______
//      \_____  \\   __\_  __ \__  \\   __\__  \   / ___\|  |  \/  ___/
//      /        \|  |  |  | \// __ \|  |  / __ \_/ /_/  >  |  /\___ |
//     /_______  /|__|  |__|  (____  /__| (____  /\___  /|____//____  >
//             \/                  \/          \//_____/            \/
//  ______________________                           ______________________
//                        T H E   W A R   B E G I N S
//         Stratagus - A free fantasy real time strategy game engine
//
//      (c) Copyright 2022 by Andrettin
//
//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; only version 2 of the License.
//
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//      02111-1307, USA.

#pragma once

namespace wyrmgus {

enum class colorization_type {
	none,
	blue,
	gray,
	green,
	red,
	white,
	yellow
};

inline colorization_type string_to_colorization_type(const std::string &str)
{
	if (str == "none") {
		return colorization_type::none;
	} else if (str == "blue") {
		return colorization_type::blue;
	} else if (str == "gray") {
		return colorization_type::gray;
	} else if (str == "green") {
		return colorization_type::green;
	} else if (str == "red") {
		return colorization_type::red;
	} else if (str == "white") {
		return colorization_type::white;
	} else if (str == "yellow") {
		return colorization_type::yellow;
	}

	throw std::runtime_error("Invalid colorization type: \"" + str + "\".");
}

}

Q_DECLARE_METATYPE(wyrmgus::colorization_type)
